uab.classes.BaseAction = uab.mixins.aceOO.Class(IActionData)

function uab.classes.BaseAction.CalculateCooldown(start, duration)
    local curtime = GetTime()
    local remaining = duration - (curtime - start)
    local cooldown

    if remaining >= 60 then      -- more than a minute, show ##:##
        remaining = floor(remaining)
        
        local minutes = floor(remaining / 60)
        
        if minutes >= 60 then    -- more than an hour, show #:##:##
            local hours = floor(minutes / 60)

            minutes = minutes - (hours * 60)
            
            remaining = remaining - (((hours * 60) + minutes) * 60)
            
            cooldown = string.format("%d:%2.2d", hours, minutes)
        else
            remaining = remaining - (minutes * 60)
            
            cooldown = string.format("%d:%2.2d", minutes, remaining)
        end
    else
        cooldown = string.format("%.2f", remaining)
    end
        
    return cooldown
end

function uab.classes.BaseAction.prototype:init(data)
    uab.classes.BaseAction.super.prototype.init(self)
end    

function uab.classes.BaseAction.prototype:GetAttributes()
end

function uab.classes.BaseAction.prototype:GetClassName()
end

function uab.classes.BaseAction.prototype:GetIcon()
	if not self.icon then
		self:SetIcon()
    end
    
	return self.icon	
end

function uab.classes.BaseAction.prototype:GetText()
	return self.text
end

function uab.classes.BaseAction.prototype:GetCooldown()
end

function uab.classes.BaseAction.prototype:GetCount()
end

function uab.classes.BaseAction.prototype:ShowTooltip(frame)
end

