uab.classes.MacroAction = uab.mixins.aceOO.Class(uab.classes.BaseAction)

function uab.classes.MacroAction.prototype:init(data)
	uab.classes.MacroAction.super.prototype.init(self)
	
	self.data = data
    self.text = self.data.name

	self:SetIcon()
end

function uab.classes.MacroAction.prototype:GetAttributes()
    local attribs = {}

    attribs["type"] = "macro"
    attribs["macro"] = self.text
    
    return attribs
end

function uab.classes.MacroAction.prototype:GetClassName()
	return "ItemAction"
end

function uab.classes.MacroAction.prototype:IsUsable()
    return true
end

function uab.classes.MacroAction.prototype:ShowTooltip(frame)
    --[[
    Need to find the referenced item.  Look in the player's inventory first.
    If not there, look in the player's bags.
    --]]

    GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
    GameTooltip:SetBackdropColor(0.1, 0.1, 0.1, 0.8)

    for id = GetNumMacros(), 1, -1 do
        local name, texture, _, _ = GetMacroInfo(id)
        
        if name == self.data.name then
            GameTooltip:SetText(self.data.name)
            return
        end
    end
end

--[[---------------------------------------------------------------------------
Helper methods, to be used only by the class itself
-----------------------------------------------------------------------------]]

function uab.classes.MacroAction.prototype:SetIcon()
    self.icon = self.data.icon
    
    if not self.icon then
    	--[[
    	Need to find the referenced macro based on the name of the macro.
    	--]]

        for id = GetNumMacros(), 1, -1 do
            local name, texture, _, _ = GetMacroInfo(id)
            
            if name == self.data.name then
                self.icon = texture
                return
            end
        end
    end
    
    self.data.icon = self.icon
end

