local uabStatus_LowMana = uabUnitStatus:NewModule("Low on Mana")
uabStatus_LowMana.defaultDB = {
    disabled = nil,
    threshold = 0.35,
    priority = 50,
    color = { r = 0,    g = 1,    b = 1, a = 1, },
    classfilter = {
        druid = true,
        hunter = true,
        mage = true,
        paladin = true,
        priest = true,
        rogue = nil,
        shaman = true,
        warlock = true,
        warrior = nil,
    },
}

function uabStatus_LowMana:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus(self.name)
end

function uabStatus_LowMana:OnEnable()
end

function uabStatus_LowMana:OnDisable()
end

function uabStatus_LowMana:IsStatusGained(name, unit, action)
	if name == self.name then
	    if not unit then return end

        local class = self:GetUnitClass(unit)
        
        if not class or self.db.profile.classfilter[class] then
            local curmana = UnitMana(unit)
    	    local maxmana = UnitManaMax(unit)
    
    	    return curmana and maxmana and curmana < (maxmana * self.db.profile.threshold)
        end
	end
end

function uabStatus_LowMana:CreateUnitStatusOptions()
    local options = self:CreateUnitStatusOption(self.db.profile, "Low Mana", "Low Mana", true)

    options.args.threshold = {
        type = 'range',
        name = "Threshold",
        desc = "Low mana threshold",
        order = 100,
        min = 0.05,
        max = 1.00,
        step = 0.05,
        isPercent = true,
        get = function()
            return self.db.profile.threshold
        end,
        set = function(value)
            self.db.profile.threshold = value
        end,
    }

    return options
end

